/* gitg-animated-paned.c generated by valac 0.44.6, the Vala compiler
 * generated from gitg-animated-paned.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2014 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gio/gio.h>

typedef enum  {
	GITG_SLIDE_DIRECTION_IN,
	GITG_SLIDE_DIRECTION_OUT
} GitgSlideDirection;

#define GITG_TYPE_SLIDE_DIRECTION (gitg_slide_direction_get_type ())
typedef enum  {
	GITG_SLIDE_PANED_CHILD_FIRST,
	GITG_SLIDE_PANED_CHILD_SECOND
} GitgSlidePanedChild;

#define GITG_TYPE_SLIDE_PANED_CHILD (gitg_slide_paned_child_get_type ())

#define GITG_TYPE_ANIMATED_PANED (gitg_animated_paned_get_type ())
#define GITG_ANIMATED_PANED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GITG_TYPE_ANIMATED_PANED, GitgAnimatedPaned))
#define GITG_ANIMATED_PANED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GITG_TYPE_ANIMATED_PANED, GitgAnimatedPanedClass))
#define GITG_IS_ANIMATED_PANED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GITG_TYPE_ANIMATED_PANED))
#define GITG_IS_ANIMATED_PANED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GITG_TYPE_ANIMATED_PANED))
#define GITG_ANIMATED_PANED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GITG_TYPE_ANIMATED_PANED, GitgAnimatedPanedClass))

typedef struct _GitgAnimatedPaned GitgAnimatedPaned;
typedef struct _GitgAnimatedPanedClass GitgAnimatedPanedClass;
typedef struct _GitgAnimatedPanedPrivate GitgAnimatedPanedPrivate;
enum  {
	GITG_ANIMATED_PANED_0_PROPERTY,
	GITG_ANIMATED_PANED_TRANSITION_DURATION_PROPERTY,
	GITG_ANIMATED_PANED_IS_ANIMATING_PROPERTY,
	GITG_ANIMATED_PANED_NUM_PROPERTIES
};
static GParamSpec* gitg_animated_paned_properties[GITG_ANIMATED_PANED_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GitgAnimatedPanedSlideAsyncData GitgAnimatedPanedSlideAsyncData;

struct _GitgAnimatedPaned {
	GtkPaned parent_instance;
	GitgAnimatedPanedPrivate * priv;
};

struct _GitgAnimatedPanedClass {
	GtkPanedClass parent_class;
};

struct _GitgAnimatedPanedPrivate {
	gint d_target_pos;
	gint d_original_pos;
	gint d_start_pos;
	gint64 d_slide_start;
	gint64 d_slide_duration;
	guint d_tick_id;
	GSourceFunc d_async_callback;
	gpointer d_async_callback_target;
	GDestroyNotify d_async_callback_target_destroy_notify;
	GitgSlideDirection d_direction;
	GitgSlidePanedChild d_child;
	guint _transition_duration;
};

struct _GitgAnimatedPanedSlideAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GitgAnimatedPaned* self;
	GitgSlidePanedChild child;
	GitgSlideDirection direction;
	gboolean should_animate;
	GtkSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GdkFrameClock* _tmp4_;
	gdouble factor;
	gint w;
	GtkOrientation _tmp5_;
	GtkOrientation _tmp6_;
	gdouble div;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	guint _tmp9_;
};

static gint GitgAnimatedPaned_private_offset;
static gpointer gitg_animated_paned_parent_class = NULL;

GType gitg_slide_direction_get_type (void) G_GNUC_CONST;
GType gitg_slide_paned_child_get_type (void) G_GNUC_CONST;
GType gitg_animated_paned_get_type (void) G_GNUC_CONST;
static gboolean gitg_animated_paned_update_position (GitgAnimatedPaned* self,
                                              gdouble factor);
static gboolean gitg_animated_paned_on_animate_step (GitgAnimatedPaned* self,
                                              GtkWidget* widget,
                                              GdkFrameClock* clock);
static void gitg_animated_paned_real_dispose (GObject* base);
void gitg_animated_paned_slide (GitgAnimatedPaned* self,
                                GitgSlidePanedChild child,
                                GitgSlideDirection direction);
static void gitg_animated_paned_slide_async (GitgAnimatedPaned* self,
                                      GitgSlidePanedChild child,
                                      GitgSlideDirection direction,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void gitg_animated_paned_slide_finish (GitgAnimatedPaned* self,
                                       GAsyncResult* _res_);
static void __lambda89_ (GitgAnimatedPaned* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda89__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void gitg_animated_paned_slide_async_data_free (gpointer _data);
static void gitg_animated_paned_slide_async_async_ready_wrapper (GObject *source_object,
                                                          GAsyncResult *res,
                                                          void *user_data);
static gboolean gitg_animated_paned_slide_async_co (GitgAnimatedPanedSlideAsyncData* _data_);
static gboolean _gitg_animated_paned_on_animate_step_gtk_tick_callback (GtkWidget* widget,
                                                                 GdkFrameClock* frame_clock,
                                                                 gpointer self);
static gboolean _gitg_animated_paned_slide_async_co_gsource_func (gpointer self);
guint gitg_animated_paned_get_transition_duration (GitgAnimatedPaned* self);
static gboolean ___lambda88_ (GitgAnimatedPaned* self);
static gboolean ____lambda88__gsource_func (gpointer self);
GitgAnimatedPaned* gitg_animated_paned_new (void);
GitgAnimatedPaned* gitg_animated_paned_construct (GType object_type);
void gitg_animated_paned_set_transition_duration (GitgAnimatedPaned* self,
                                                  guint value);
gboolean gitg_animated_paned_get_is_animating (GitgAnimatedPaned* self);
static void gitg_animated_paned_finalize (GObject * obj);
static void _vala_gitg_animated_paned_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_gitg_animated_paned_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

GType
gitg_slide_direction_get_type (void)
{
	static volatile gsize gitg_slide_direction_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_slide_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{GITG_SLIDE_DIRECTION_IN, "GITG_SLIDE_DIRECTION_IN", "in"}, {GITG_SLIDE_DIRECTION_OUT, "GITG_SLIDE_DIRECTION_OUT", "out"}, {0, NULL, NULL}};
		GType gitg_slide_direction_type_id;
		gitg_slide_direction_type_id = g_enum_register_static ("GitgSlideDirection", values);
		g_once_init_leave (&gitg_slide_direction_type_id__volatile, gitg_slide_direction_type_id);
	}
	return gitg_slide_direction_type_id__volatile;
}

GType
gitg_slide_paned_child_get_type (void)
{
	static volatile gsize gitg_slide_paned_child_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_slide_paned_child_type_id__volatile)) {
		static const GEnumValue values[] = {{GITG_SLIDE_PANED_CHILD_FIRST, "GITG_SLIDE_PANED_CHILD_FIRST", "first"}, {GITG_SLIDE_PANED_CHILD_SECOND, "GITG_SLIDE_PANED_CHILD_SECOND", "second"}, {0, NULL, NULL}};
		GType gitg_slide_paned_child_type_id;
		gitg_slide_paned_child_type_id = g_enum_register_static ("GitgSlidePanedChild", values);
		g_once_init_leave (&gitg_slide_paned_child_type_id__volatile, gitg_slide_paned_child_type_id);
	}
	return gitg_slide_paned_child_type_id__volatile;
}

static inline gpointer
gitg_animated_paned_get_instance_private (GitgAnimatedPaned* self)
{
	return G_STRUCT_MEMBER_P (self, GitgAnimatedPaned_private_offset);
}

static gboolean
gitg_animated_paned_update_position (GitgAnimatedPaned* self,
                                     gdouble factor)
{
	gboolean result = FALSE;
	gint pos = 0;
#line 54 "../gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../gitg/gitg-animated-paned.vala"
	pos = ((gint) round ((self->priv->d_target_pos - self->priv->d_start_pos) * factor)) + self->priv->d_start_pos;
#line 58 "../gitg/gitg-animated-paned.vala"
	gtk_paned_set_position ((GtkPaned*) self, pos);
#line 59 "../gitg/gitg-animated-paned.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 61 "../gitg/gitg-animated-paned.vala"
	if (pos == self->priv->d_target_pos) {
#line 218 "gitg-animated-paned.c"
		GSourceFunc _tmp0_;
		gpointer _tmp0__target;
		GitgSlideDirection _tmp2_;
#line 63 "../gitg/gitg-animated-paned.vala"
		self->priv->d_tick_id = (guint) 0;
#line 65 "../gitg/gitg-animated-paned.vala"
		_tmp0_ = self->priv->d_async_callback;
#line 65 "../gitg/gitg-animated-paned.vala"
		_tmp0__target = self->priv->d_async_callback_target;
#line 65 "../gitg/gitg-animated-paned.vala"
		if (_tmp0_ != NULL) {
#line 230 "gitg-animated-paned.c"
			GSourceFunc _tmp1_;
			gpointer _tmp1__target;
#line 67 "../gitg/gitg-animated-paned.vala"
			_tmp1_ = self->priv->d_async_callback;
#line 67 "../gitg/gitg-animated-paned.vala"
			_tmp1__target = self->priv->d_async_callback_target;
#line 67 "../gitg/gitg-animated-paned.vala"
			_tmp1_ (_tmp1__target);
#line 239 "gitg-animated-paned.c"
		}
#line 70 "../gitg/gitg-animated-paned.vala"
		_tmp2_ = self->priv->d_direction;
#line 70 "../gitg/gitg-animated-paned.vala"
		if (_tmp2_ == GITG_SLIDE_DIRECTION_OUT) {
#line 245 "gitg-animated-paned.c"
			GitgSlidePanedChild _tmp3_;
#line 72 "../gitg/gitg-animated-paned.vala"
			_tmp3_ = self->priv->d_child;
#line 72 "../gitg/gitg-animated-paned.vala"
			if (_tmp3_ == GITG_SLIDE_PANED_CHILD_FIRST) {
#line 251 "gitg-animated-paned.c"
				GtkWidget* _tmp4_;
#line 74 "../gitg/gitg-animated-paned.vala"
				_tmp4_ = gtk_paned_get_child1 ((GtkPaned*) self);
#line 74 "../gitg/gitg-animated-paned.vala"
				gtk_widget_hide (_tmp4_);
#line 257 "gitg-animated-paned.c"
			} else {
				GtkWidget* _tmp5_;
#line 78 "../gitg/gitg-animated-paned.vala"
				_tmp5_ = gtk_paned_get_child2 ((GtkPaned*) self);
#line 78 "../gitg/gitg-animated-paned.vala"
				gtk_widget_hide (_tmp5_);
#line 264 "gitg-animated-paned.c"
			}
		}
#line 82 "../gitg/gitg-animated-paned.vala"
		result = FALSE;
#line 82 "../gitg/gitg-animated-paned.vala"
		return result;
#line 271 "gitg-animated-paned.c"
	}
#line 85 "../gitg/gitg-animated-paned.vala"
	result = TRUE;
#line 85 "../gitg/gitg-animated-paned.vala"
	return result;
#line 277 "gitg-animated-paned.c"
}

static gboolean
gitg_animated_paned_on_animate_step (GitgAnimatedPaned* self,
                                     GtkWidget* widget,
                                     GdkFrameClock* clock)
{
	gboolean result = FALSE;
	gint64 elapsed = 0LL;
	gdouble factor = 0.0;
#line 88 "../gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 88 "../gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (clock != NULL, FALSE);
#line 90 "../gitg/gitg-animated-paned.vala"
	elapsed = gdk_frame_clock_get_frame_time (clock) - self->priv->d_slide_start;
#line 91 "../gitg/gitg-animated-paned.vala"
	factor = ((gdouble) elapsed) / ((gdouble) self->priv->d_slide_duration);
#line 93 "../gitg/gitg-animated-paned.vala"
	if (!gitg_animated_paned_update_position (self, fmin (factor, (gdouble) 1))) {
#line 95 "../gitg/gitg-animated-paned.vala"
		self->priv->d_tick_id = (guint) 0;
#line 96 "../gitg/gitg-animated-paned.vala"
		g_object_notify ((GObject*) self, "is-animating");
#line 97 "../gitg/gitg-animated-paned.vala"
		result = FALSE;
#line 97 "../gitg/gitg-animated-paned.vala"
		return result;
#line 308 "gitg-animated-paned.c"
	}
#line 100 "../gitg/gitg-animated-paned.vala"
	result = TRUE;
#line 100 "../gitg/gitg-animated-paned.vala"
	return result;
#line 314 "gitg-animated-paned.c"
}

static void
gitg_animated_paned_real_dispose (GObject* base)
{
	GitgAnimatedPaned * self;
#line 103 "../gitg/gitg-animated-paned.vala"
	self = (GitgAnimatedPaned*) base;
#line 105 "../gitg/gitg-animated-paned.vala"
	if (self->priv->d_tick_id != ((guint) 0)) {
#line 107 "../gitg/gitg-animated-paned.vala"
		gtk_widget_remove_tick_callback ((GtkWidget*) self, self->priv->d_tick_id);
#line 108 "../gitg/gitg-animated-paned.vala"
		self->priv->d_tick_id = (guint) 0;
#line 329 "gitg-animated-paned.c"
	}
#line 111 "../gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (gitg_animated_paned_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_paned_get_type (), GtkPaned));
#line 333 "gitg-animated-paned.c"
}

static void
__lambda89_ (GitgAnimatedPaned* self,
             GObject* obj,
             GAsyncResult* res)
{
#line 122 "../gitg/gitg-animated-paned.vala"
	g_return_if_fail (res != NULL);
#line 123 "../gitg/gitg-animated-paned.vala"
	gitg_animated_paned_slide_finish (self, res);
#line 345 "gitg-animated-paned.c"
}

static void
___lambda89__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 122 "../gitg/gitg-animated-paned.vala"
	__lambda89_ ((GitgAnimatedPaned*) self, source_object, res);
#line 122 "../gitg/gitg-animated-paned.vala"
	g_object_unref (self);
#line 357 "gitg-animated-paned.c"
}

void
gitg_animated_paned_slide (GitgAnimatedPaned* self,
                           GitgSlidePanedChild child,
                           GitgSlideDirection direction)
{
#line 119 "../gitg/gitg-animated-paned.vala"
	g_return_if_fail (self != NULL);
#line 122 "../gitg/gitg-animated-paned.vala"
	gitg_animated_paned_slide_async (self, child, direction, ___lambda89__gasync_ready_callback, g_object_ref (self));
#line 369 "gitg-animated-paned.c"
}

static void
gitg_animated_paned_slide_async_data_free (gpointer _data)
{
	GitgAnimatedPanedSlideAsyncData* _data_;
	_data_ = _data;
#line 35 "../gitg/gitg-animated-paned.vala"
	_g_object_unref0 (_data_->self);
#line 35 "../gitg/gitg-animated-paned.vala"
	g_slice_free (GitgAnimatedPanedSlideAsyncData, _data_);
#line 381 "gitg-animated-paned.c"
}

static void
gitg_animated_paned_slide_async_async_ready_wrapper (GObject *source_object,
                                                     GAsyncResult *res,
                                                     void *user_data)
{
	GitgAnimatedPanedSlideAsyncData* _task_data_;
#line 35 "../gitg/gitg-animated-paned.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 35 "../gitg/gitg-animated-paned.vala"
	if (_task_data_->_callback_ != NULL) {
#line 35 "../gitg/gitg-animated-paned.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 396 "gitg-animated-paned.c"
	}
#line 35 "../gitg/gitg-animated-paned.vala"
	_task_data_->_task_complete_ = TRUE;
#line 400 "gitg-animated-paned.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "../gitg/gitg-animated-paned.vala"
	return self ? g_object_ref (self) : NULL;
#line 408 "gitg-animated-paned.c"
}

static void
gitg_animated_paned_slide_async (GitgAnimatedPaned* self,
                                 GitgSlidePanedChild child,
                                 GitgSlideDirection direction,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	GitgAnimatedPanedSlideAsyncData* _data_;
	GitgAnimatedPaned* _tmp0_;
#line 35 "../gitg/gitg-animated-paned.vala"
	_data_ = g_slice_new0 (GitgAnimatedPanedSlideAsyncData);
#line 35 "../gitg/gitg-animated-paned.vala"
	_data_->_callback_ = _callback_;
#line 35 "../gitg/gitg-animated-paned.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, gitg_animated_paned_slide_async_async_ready_wrapper, _user_data_);
#line 35 "../gitg/gitg-animated-paned.vala"
	if (_callback_ == NULL) {
#line 35 "../gitg/gitg-animated-paned.vala"
		_data_->_task_complete_ = TRUE;
#line 430 "gitg-animated-paned.c"
	}
#line 35 "../gitg/gitg-animated-paned.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gitg_animated_paned_slide_async_data_free);
#line 35 "../gitg/gitg-animated-paned.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 35 "../gitg/gitg-animated-paned.vala"
	_data_->self = _tmp0_;
#line 35 "../gitg/gitg-animated-paned.vala"
	_data_->child = child;
#line 35 "../gitg/gitg-animated-paned.vala"
	_data_->direction = direction;
#line 35 "../gitg/gitg-animated-paned.vala"
	gitg_animated_paned_slide_async_co (_data_);
#line 444 "gitg-animated-paned.c"
}

static void
gitg_animated_paned_slide_finish (GitgAnimatedPaned* self,
                                  GAsyncResult* _res_)
{
	GitgAnimatedPanedSlideAsyncData* _data_;
#line 35 "../gitg/gitg-animated-paned.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 454 "gitg-animated-paned.c"
}

static gboolean
_gitg_animated_paned_on_animate_step_gtk_tick_callback (GtkWidget* widget,
                                                        GdkFrameClock* frame_clock,
                                                        gpointer self)
{
	gboolean result;
	result = gitg_animated_paned_on_animate_step ((GitgAnimatedPaned*) self, widget, frame_clock);
#line 141 "../gitg/gitg-animated-paned.vala"
	return result;
#line 466 "gitg-animated-paned.c"
}

static gboolean
_gitg_animated_paned_slide_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = gitg_animated_paned_slide_async_co (self);
#line 203 "../gitg/gitg-animated-paned.vala"
	return result;
#line 476 "gitg-animated-paned.c"
}

static gboolean
___lambda88_ (GitgAnimatedPaned* self)
{
	gboolean result = FALSE;
#line 212 "../gitg/gitg-animated-paned.vala"
	gitg_animated_paned_update_position (self, (gdouble) 1);
#line 213 "../gitg/gitg-animated-paned.vala"
	result = FALSE;
#line 213 "../gitg/gitg-animated-paned.vala"
	return result;
#line 489 "gitg-animated-paned.c"
}

static gboolean
____lambda88__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda88_ ((GitgAnimatedPaned*) self);
#line 211 "../gitg/gitg-animated-paned.vala"
	return result;
#line 499 "gitg-animated-paned.c"
}

static gboolean
gitg_animated_paned_slide_async_co (GitgAnimatedPanedSlideAsyncData* _data_)
{
#line 127 "../gitg/gitg-animated-paned.vala"
	switch (_data_->_state_) {
#line 127 "../gitg/gitg-animated-paned.vala"
		case 0:
#line 509 "gitg-animated-paned.c"
		goto _state_0;
#line 127 "../gitg/gitg-animated-paned.vala"
		case 1:
#line 513 "gitg-animated-paned.c"
		goto _state_1;
		default:
#line 127 "../gitg/gitg-animated-paned.vala"
		g_assert_not_reached ();
#line 518 "gitg-animated-paned.c"
	}
	_state_0:
#line 130 "../gitg/gitg-animated-paned.vala"
	_data_->_tmp0_ = gtk_widget_get_settings ((GtkWidget*) _data_->self);
#line 130 "../gitg/gitg-animated-paned.vala"
	g_object_get (_data_->_tmp0_, "gtk-enable-animations", &_data_->_tmp1_, NULL);
#line 130 "../gitg/gitg-animated-paned.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 130 "../gitg/gitg-animated-paned.vala"
	_data_->should_animate = _data_->_tmp2_;
#line 132 "../gitg/gitg-animated-paned.vala"
	if (_data_->self->priv->d_tick_id == ((guint) 0)) {
#line 134 "../gitg/gitg-animated-paned.vala"
		if (_data_->direction == GITG_SLIDE_DIRECTION_OUT) {
#line 136 "../gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_original_pos = gtk_paned_get_position ((GtkPaned*) _data_->self);
#line 535 "gitg-animated-paned.c"
		}
#line 139 "../gitg/gitg-animated-paned.vala"
		if (_data_->should_animate) {
#line 141 "../gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_tick_id = gtk_widget_add_tick_callback ((GtkWidget*) _data_->self, _gitg_animated_paned_on_animate_step_gtk_tick_callback, g_object_ref (_data_->self), g_object_unref);
#line 142 "../gitg/gitg-animated-paned.vala"
			g_object_notify ((GObject*) _data_->self, "is-animating");
#line 543 "gitg-animated-paned.c"
		}
	} else {
#line 145 "../gitg/gitg-animated-paned.vala"
		if (_data_->self->priv->d_tick_id != ((guint) 0)) {
#line 145 "../gitg/gitg-animated-paned.vala"
			_data_->_tmp3_ = !_data_->should_animate;
#line 550 "gitg-animated-paned.c"
		} else {
#line 145 "../gitg/gitg-animated-paned.vala"
			_data_->_tmp3_ = FALSE;
#line 554 "gitg-animated-paned.c"
		}
#line 145 "../gitg/gitg-animated-paned.vala"
		if (_data_->_tmp3_) {
#line 147 "../gitg/gitg-animated-paned.vala"
			gtk_widget_remove_tick_callback ((GtkWidget*) _data_->self, _data_->self->priv->d_tick_id);
#line 148 "../gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_tick_id = (guint) 0;
#line 149 "../gitg/gitg-animated-paned.vala"
			g_object_notify ((GObject*) _data_->self, "is-animating");
#line 564 "gitg-animated-paned.c"
		}
	}
#line 152 "../gitg/gitg-animated-paned.vala"
	_data_->_tmp4_ = gtk_widget_get_frame_clock ((GtkWidget*) _data_->self);
#line 152 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_slide_start = gdk_frame_clock_get_frame_time (_data_->_tmp4_);
#line 153 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_start_pos = gtk_paned_get_position ((GtkPaned*) _data_->self);
#line 154 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_direction = _data_->direction;
#line 155 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_child = _data_->child;
#line 160 "../gitg/gitg-animated-paned.vala"
	_data_->_tmp5_ = gtk_orientable_get_orientation ((GtkOrientable*) _data_->self);
#line 160 "../gitg/gitg-animated-paned.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 160 "../gitg/gitg-animated-paned.vala"
	if (_data_->_tmp6_ == GTK_ORIENTATION_VERTICAL) {
#line 162 "../gitg/gitg-animated-paned.vala"
		_data_->w = gtk_widget_get_allocated_height ((GtkWidget*) _data_->self);
#line 585 "gitg-animated-paned.c"
	} else {
#line 166 "../gitg/gitg-animated-paned.vala"
		_data_->w = gtk_widget_get_allocated_width ((GtkWidget*) _data_->self);
#line 589 "gitg-animated-paned.c"
	}
#line 169 "../gitg/gitg-animated-paned.vala"
	if (_data_->direction == GITG_SLIDE_DIRECTION_OUT) {
#line 171 "../gitg/gitg-animated-paned.vala"
		if (_data_->child == GITG_SLIDE_PANED_CHILD_FIRST) {
#line 173 "../gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_target_pos = 0;
#line 597 "gitg-animated-paned.c"
		} else {
#line 177 "../gitg/gitg-animated-paned.vala"
			_data_->self->priv->d_target_pos = _data_->w;
#line 601 "gitg-animated-paned.c"
		}
#line 180 "../gitg/gitg-animated-paned.vala"
		_data_->factor = (((gdouble) _data_->self->priv->d_target_pos) - ((gdouble) _data_->self->priv->d_start_pos)) / (((gdouble) _data_->self->priv->d_target_pos) - ((gdouble) _data_->self->priv->d_original_pos));
#line 605 "gitg-animated-paned.c"
	} else {
#line 185 "../gitg/gitg-animated-paned.vala"
		_data_->self->priv->d_target_pos = _data_->self->priv->d_original_pos;
#line 189 "../gitg/gitg-animated-paned.vala"
		if (_data_->child == GITG_SLIDE_PANED_CHILD_FIRST) {
#line 191 "../gitg/gitg-animated-paned.vala"
			_data_->div = (gdouble) _data_->self->priv->d_original_pos;
#line 192 "../gitg/gitg-animated-paned.vala"
			_data_->_tmp7_ = gtk_paned_get_child1 ((GtkPaned*) _data_->self);
#line 192 "../gitg/gitg-animated-paned.vala"
			gtk_widget_show (_data_->_tmp7_);
#line 617 "gitg-animated-paned.c"
		} else {
#line 196 "../gitg/gitg-animated-paned.vala"
			_data_->div = (gdouble) (_data_->self->priv->d_original_pos - _data_->w);
#line 197 "../gitg/gitg-animated-paned.vala"
			_data_->_tmp8_ = gtk_paned_get_child2 ((GtkPaned*) _data_->self);
#line 197 "../gitg/gitg-animated-paned.vala"
			gtk_widget_show (_data_->_tmp8_);
#line 625 "gitg-animated-paned.c"
		}
#line 200 "../gitg/gitg-animated-paned.vala"
		_data_->factor = (((gdouble) _data_->self->priv->d_target_pos) - ((gdouble) _data_->self->priv->d_start_pos)) / _data_->div;
#line 629 "gitg-animated-paned.c"
	}
#line 203 "../gitg/gitg-animated-paned.vala"
	(_data_->self->priv->d_async_callback_target_destroy_notify == NULL) ? NULL : (_data_->self->priv->d_async_callback_target_destroy_notify (_data_->self->priv->d_async_callback_target), NULL);
#line 203 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback = NULL;
#line 203 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback_target = NULL;
#line 203 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback_target_destroy_notify = NULL;
#line 203 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback = _gitg_animated_paned_slide_async_co_gsource_func;
#line 203 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback_target = _data_;
#line 203 "../gitg/gitg-animated-paned.vala"
	_data_->self->priv->d_async_callback_target_destroy_notify = NULL;
#line 205 "../gitg/gitg-animated-paned.vala"
	if (_data_->should_animate) {
#line 207 "../gitg/gitg-animated-paned.vala"
		_data_->_tmp9_ = _data_->self->priv->_transition_duration;
#line 207 "../gitg/gitg-animated-paned.vala"
		_data_->self->priv->d_slide_duration = ((gint64) (_data_->factor * _data_->_tmp9_)) * 1000;
#line 651 "gitg-animated-paned.c"
	} else {
#line 211 "../gitg/gitg-animated-paned.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda88__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 655 "gitg-animated-paned.c"
	}
#line 217 "../gitg/gitg-animated-paned.vala"
	_data_->_state_ = 1;
#line 217 "../gitg/gitg-animated-paned.vala"
	return FALSE;
#line 661 "gitg-animated-paned.c"
	_state_1:
	;
#line 127 "../gitg/gitg-animated-paned.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 127 "../gitg/gitg-animated-paned.vala"
	if (_data_->_state_ != 0) {
#line 127 "../gitg/gitg-animated-paned.vala"
		while (!_data_->_task_complete_) {
#line 127 "../gitg/gitg-animated-paned.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 672 "gitg-animated-paned.c"
		}
	}
#line 127 "../gitg/gitg-animated-paned.vala"
	g_object_unref (_data_->_async_result);
#line 127 "../gitg/gitg-animated-paned.vala"
	return FALSE;
#line 679 "gitg-animated-paned.c"
}

GitgAnimatedPaned*
gitg_animated_paned_construct (GType object_type)
{
	GitgAnimatedPaned * self = NULL;
#line 35 "../gitg/gitg-animated-paned.vala"
	self = (GitgAnimatedPaned*) g_object_new (object_type, NULL);
#line 35 "../gitg/gitg-animated-paned.vala"
	return self;
#line 690 "gitg-animated-paned.c"
}

GitgAnimatedPaned*
gitg_animated_paned_new (void)
{
#line 35 "../gitg/gitg-animated-paned.vala"
	return gitg_animated_paned_construct (GITG_TYPE_ANIMATED_PANED);
#line 698 "gitg-animated-paned.c"
}

guint
gitg_animated_paned_get_transition_duration (GitgAnimatedPaned* self)
{
	guint result;
#line 49 "../gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 49 "../gitg/gitg-animated-paned.vala"
	result = self->priv->_transition_duration;
#line 49 "../gitg/gitg-animated-paned.vala"
	return result;
#line 711 "gitg-animated-paned.c"
}

void
gitg_animated_paned_set_transition_duration (GitgAnimatedPaned* self,
                                             guint value)
{
#line 50 "../gitg/gitg-animated-paned.vala"
	g_return_if_fail (self != NULL);
#line 50 "../gitg/gitg-animated-paned.vala"
	if (gitg_animated_paned_get_transition_duration (self) != value) {
#line 50 "../gitg/gitg-animated-paned.vala"
		self->priv->_transition_duration = value;
#line 50 "../gitg/gitg-animated-paned.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_animated_paned_properties[GITG_ANIMATED_PANED_TRANSITION_DURATION_PROPERTY]);
#line 726 "gitg-animated-paned.c"
	}
}

gboolean
gitg_animated_paned_get_is_animating (GitgAnimatedPaned* self)
{
	gboolean result;
#line 116 "../gitg/gitg-animated-paned.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 116 "../gitg/gitg-animated-paned.vala"
	result = self->priv->d_tick_id != ((guint) 0);
#line 116 "../gitg/gitg-animated-paned.vala"
	return result;
#line 740 "gitg-animated-paned.c"
}

static void
gitg_animated_paned_class_init (GitgAnimatedPanedClass * klass,
                                gpointer klass_data)
{
#line 35 "../gitg/gitg-animated-paned.vala"
	gitg_animated_paned_parent_class = g_type_class_peek_parent (klass);
#line 35 "../gitg/gitg-animated-paned.vala"
	g_type_class_adjust_private_offset (klass, &GitgAnimatedPaned_private_offset);
#line 35 "../gitg/gitg-animated-paned.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) gitg_animated_paned_real_dispose;
#line 35 "../gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_animated_paned_get_property;
#line 35 "../gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_animated_paned_set_property;
#line 35 "../gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_animated_paned_finalize;
#line 35 "../gitg/gitg-animated-paned.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_ANIMATED_PANED_TRANSITION_DURATION_PROPERTY, gitg_animated_paned_properties[GITG_ANIMATED_PANED_TRANSITION_DURATION_PROPERTY] = g_param_spec_uint ("transition-duration", "transition-duration", "transition-duration", 0, G_MAXUINT, (guint) 250, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 35 "../gitg/gitg-animated-paned.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_ANIMATED_PANED_IS_ANIMATING_PROPERTY, gitg_animated_paned_properties[GITG_ANIMATED_PANED_IS_ANIMATING_PROPERTY] = g_param_spec_boolean ("is-animating", "is-animating", "is-animating", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 763 "gitg-animated-paned.c"
}

static void
gitg_animated_paned_instance_init (GitgAnimatedPaned * self,
                                   gpointer klass)
{
#line 35 "../gitg/gitg-animated-paned.vala"
	self->priv = gitg_animated_paned_get_instance_private (self);
#line 47 "../gitg/gitg-animated-paned.vala"
	self->priv->_transition_duration = (guint) 250;
#line 774 "gitg-animated-paned.c"
}

static void
gitg_animated_paned_finalize (GObject * obj)
{
	GitgAnimatedPaned * self;
#line 35 "../gitg/gitg-animated-paned.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_ANIMATED_PANED, GitgAnimatedPaned);
#line 43 "../gitg/gitg-animated-paned.vala"
	(self->priv->d_async_callback_target_destroy_notify == NULL) ? NULL : (self->priv->d_async_callback_target_destroy_notify (self->priv->d_async_callback_target), NULL);
#line 43 "../gitg/gitg-animated-paned.vala"
	self->priv->d_async_callback = NULL;
#line 43 "../gitg/gitg-animated-paned.vala"
	self->priv->d_async_callback_target = NULL;
#line 43 "../gitg/gitg-animated-paned.vala"
	self->priv->d_async_callback_target_destroy_notify = NULL;
#line 35 "../gitg/gitg-animated-paned.vala"
	G_OBJECT_CLASS (gitg_animated_paned_parent_class)->finalize (obj);
#line 793 "gitg-animated-paned.c"
}

GType
gitg_animated_paned_get_type (void)
{
	static volatile gsize gitg_animated_paned_type_id__volatile = 0;
	if (g_once_init_enter (&gitg_animated_paned_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GitgAnimatedPanedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_animated_paned_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgAnimatedPaned), 0, (GInstanceInitFunc) gitg_animated_paned_instance_init, NULL };
		GType gitg_animated_paned_type_id;
		gitg_animated_paned_type_id = g_type_register_static (gtk_paned_get_type (), "GitgAnimatedPaned", &g_define_type_info, 0);
		GitgAnimatedPaned_private_offset = g_type_add_instance_private (gitg_animated_paned_type_id, sizeof (GitgAnimatedPanedPrivate));
		g_once_init_leave (&gitg_animated_paned_type_id__volatile, gitg_animated_paned_type_id);
	}
	return gitg_animated_paned_type_id__volatile;
}

static void
_vala_gitg_animated_paned_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GitgAnimatedPaned * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_ANIMATED_PANED, GitgAnimatedPaned);
#line 35 "../gitg/gitg-animated-paned.vala"
	switch (property_id) {
#line 35 "../gitg/gitg-animated-paned.vala"
		case GITG_ANIMATED_PANED_TRANSITION_DURATION_PROPERTY:
#line 35 "../gitg/gitg-animated-paned.vala"
		g_value_set_uint (value, gitg_animated_paned_get_transition_duration (self));
#line 35 "../gitg/gitg-animated-paned.vala"
		break;
#line 35 "../gitg/gitg-animated-paned.vala"
		case GITG_ANIMATED_PANED_IS_ANIMATING_PROPERTY:
#line 35 "../gitg/gitg-animated-paned.vala"
		g_value_set_boolean (value, gitg_animated_paned_get_is_animating (self));
#line 35 "../gitg/gitg-animated-paned.vala"
		break;
#line 832 "gitg-animated-paned.c"
		default:
#line 35 "../gitg/gitg-animated-paned.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../gitg/gitg-animated-paned.vala"
		break;
#line 838 "gitg-animated-paned.c"
	}
}

static void
_vala_gitg_animated_paned_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	GitgAnimatedPaned * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_ANIMATED_PANED, GitgAnimatedPaned);
#line 35 "../gitg/gitg-animated-paned.vala"
	switch (property_id) {
#line 35 "../gitg/gitg-animated-paned.vala"
		case GITG_ANIMATED_PANED_TRANSITION_DURATION_PROPERTY:
#line 35 "../gitg/gitg-animated-paned.vala"
		gitg_animated_paned_set_transition_duration (self, g_value_get_uint (value));
#line 35 "../gitg/gitg-animated-paned.vala"
		break;
#line 858 "gitg-animated-paned.c"
		default:
#line 35 "../gitg/gitg-animated-paned.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../gitg/gitg-animated-paned.vala"
		break;
#line 864 "gitg-animated-paned.c"
	}
}

